local resetVars = function(p)
    p.nextskin = #skins - 1
end

addHook("PlayerSpawn", function(p)
	resetVars(p)
end)


addHook("PlayerThink", function(p)
    if p.chartime == nil then p.chartime = 15 return end
    if not (p.mo.state == S_PLAY_PAIN)
	    and not (p.mo.state == S_PLAY_DEAD)
	    and not (p.mo.state == S_PLAY_DRWN) then
		p.charcountdown = true
	end
end)


addHook("PlayerThink", function(p)
    if p.charcountdown
	and leveltime % 9 == 0
        p.chartime = $-1
	end
end)


addHook("PlayerThink", function(p)
	if (p.chartime <= 0) and (p.playerstate == PST_LIVE) then
		local randomizeskin = P_RandomRange(0, p.nextskin)
		R_SetPlayerSkin(p, randomizeskin)
		S_StartSound(p.mo, sfx_pop)
		p.chartime = 15
		p.charcountdown = false
	end
end)


local function randomcharhud(v, p)
	if not p.valid
	or not p.valid
		return
	end

    v.drawString(34, 166, p.chartime, V_SNAPTOBOTTOM|V_SNAPTORIGHT)
    v.drawString(15, 166, "Character:", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_YELLOWMAP)
end

hud.add(randomcharhud, "game")